//+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

extern double TakeProfit = 50;
extern double Lots = 0.1;
extern double TrailingStop = 30;
//extern double MACDOpenLevel=3;
//extern double MACDCloseLevel=2;
extern double MATrendPeriod=3;
extern   int   timeInter=55;
extern   int   timeBeforeNow=5;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//======================================================================
//+-------------------------------------
double   zHigh(int m,int n)
   {
   double zHigh=0;
   if(m<n){Alert("m<n");return;}
   for(int i=n;i<m;i++)
      {double hi=High[i];
      if(hi>zHigh)zHigh=hi;
      }//end for
      return(zHigh); 
   }
//+-------------------------------------------

//===================================================================
//+------------------------------------------------
double   zLow(int m,int n)
   {
   double L=0;
   if(m<n){Alert("m<n");return;}
   for(int i=n;i<m;i++)
      {double lw=Low[i];
      if(lw<L)L=lw;
      }//end for
      return(lw); 
   }
//+----------------------------------------------
//================================================================
int    zSell(double hi,int maPeriod)
   {double ma3,ma2,ma1,ma0;
   double hi3,hi2,hi1,h=0;
   bool s=0;
   ma0=iMA(NULL,0,maPeriod,0,MODE_SMMA,PRICE_MEDIAN,0);
   ma1=iMA(NULL,0,maPeriod,0,MODE_SMMA,PRICE_MEDIAN,1);
   ma2=iMA(NULL,0,maPeriod,0,MODE_SMMA,PRICE_MEDIAN,2);
   ma3=iMA(NULL,0,maPeriod,0,MODE_SMMA,PRICE_MEDIAN,3);
   hi1=High[1];hi2=High[2];hi3=High[3];
   //+----------------------------------------
   h=MathMax(hi1,MathMax(hi2,hi3));
   if(h>hi-5*Point)
      {if(ma3<=ma2&&ma2>=ma1&&ma1>=ma0)
         if(hi3>=hi2&&hi2>=hi1)s=1;
      }
   //+----------------------------------------------
   return(s);
   }
//===================================================================
//+--------------------------------------------------------
int    zBuy(double lw,int maPeriod)
   {double ma3,ma2,ma1,ma0;
   double l3,l2,l1,l=0;
   bool b=0;
   ma0=iMA(NULL,0,maPeriod,0,MODE_SMMA,PRICE_MEDIAN,0);
   ma1=iMA(NULL,0,maPeriod,0,MODE_SMMA,PRICE_MEDIAN,1);
   ma2=iMA(NULL,0,maPeriod,0,MODE_SMMA,PRICE_MEDIAN,2);
   ma3=iMA(NULL,0,maPeriod,0,MODE_SMMA,PRICE_MEDIAN,3);
   l1=Low[1];l2=Low[2];l3=Low[3];
   //+----------------------------------------
   l=MathMin(l1,MathMin(l2,l3));
   if(l<lw+5*Point)
      {if(ma3>=ma2&&ma2<=ma1&&ma1<=ma0)
         if(l3<=l2&&l2<=l1)b=1;//lows upping
      }
   //+----------------------------------------------
   return(b);
   }

int start()

  {
   double MacdCurrent, MacdPrevious, SignalCurrent,lw,hi;
   //double SignalPrevious, MaCurrent, MaPrevious;
   int cnt, ticket, total;
   bool bb,ss;
   lw=zLow(timeInter,timeBeforeNow);
   hi=zHigh(timeInter,timeBeforeNow);
   bb=zBuy(lw,3);ss=zSell(hi,3);
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables
   //MacdCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   //MacdPrevious=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   //SignalCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   //SignalPrevious=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
   //MaCurrent=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,0);
   //MaPrevious=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,1);

   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if(bb)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"macd sample",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if(ss)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"macd sample",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(ss||OrderOpenPrice()>Ask+Point*TrailingStop)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if(bb||OrderOpenPrice()<Ask+Point*TrailingStop)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.

